<form *ngIf="isModel" [formGroup]="cfd">
  <mat-form-field appearance="standard">
    <mat-label>Change Effective Date</mat-label>
    <input matInput readonly [matDatepicker]="cfdpicker" formControlName="changeEffectiveDate" [min]="minDate" [max]="maxDate">
    <mat-datepicker-toggle matSuffix [for]="cfdpicker"></mat-datepicker-toggle>
    <mat-datepicker #cfdpicker></mat-datepicker>
    <mat-error *ngFor="let validation of validationMessages.changeEffectiveDate">
      <mat-error class="error-message" *ngIf="  
      cfd.get('changeEffectiveDate').hasError(validation.type) &&
          (cfd.get('changeEffectiveDate').dirty ||
          cfd.get('changeEffectiveDate').touched)">{{ validation.message }}</mat-error>
    </mat-error>
  </mat-form-field>
</form>
<mat-accordion>
  <mat-expansion-panel [expanded]="true">
    <mat-expansion-panel-header>
      <mat-panel-title>
        Personal Information
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="personalInfo">
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>First Name</mat-label>
        <input matInput placeholder="" [value]="personalInfo.value.firstName" formControlName="firstName" required
          autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.firstName">
          <mat-error class="error-message" *ngIf="  
              personalInfo.get('firstName').hasError(validation.type) &&
                  (personalInfo.get('firstName').dirty ||
                  personalInfo.get('firstName').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Last Name</mat-label>
        <input matInput placeholder="" [value]="personalInfo.value.lastName" formControlName="lastName" required
          autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.lastName">
          <mat-error class="error-message" *ngIf="  
              personalInfo.get('lastName').hasError(validation.type) &&
                  (personalInfo.get('lastName').dirty ||
                  personalInfo.get('lastName').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Father Name</mat-label>
        <input matInput placeholder="" formControlName="Fathername" [value]="personalInfo.value.Fathername" required
          autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.Fathername">
          <mat-error class="error-message" *ngIf="  
              personalInfo.get('Fathername').hasError(validation.type) &&
                  (personalInfo.get('Fathername').dirty ||
                  personalInfo.get('Fathername').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Gender</mat-label>
        <mat-select name="gender" formControlName="gender">
          <mat-option *ngFor="let gender of genders" [value]="gender.code">
            {{gender.name}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.gender">
          <mat-error class="error-message" *ngIf="  
                personalInfo.get('gender').hasError(validation.type) &&
                    (personalInfo.get('gender').dirty ||
                    personalInfo.get('gender').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <P class="tool-tip">
        <mat-form-field class="email-field" appearance="standard">
          <mat-label>ID</mat-label>
          <input matInput placeholder="ID" formControlName="IqamaNo" [value]="personalInfo.value.IqamaNo" required
            autocomplete="off" />
          <mat-error *ngFor="let validation of validationMessages.IqamaNo">
            <mat-error class="error-message" *ngIf="  
                personalInfo.get('IqamaNo').hasError(validation.type) &&
                    (personalInfo.get('IqamaNo').dirty ||
                    personalInfo.get('IqamaNo').touched)">{{ validation.message }}</mat-error>
          </mat-error>
        </mat-form-field>
        <i matTooltip="Social ID/National ID/Iqama ID" class="fa fa-question-circle"></i>
      </P>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Nationality</mat-label>
        <mat-select name="country" formControlName="nationality">
          <mat-option *ngFor="let nationality of nationalities" [value]="nationality">
            {{nationality}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.nationality">
          <mat-error class="error-message" *ngIf="  
                personalInfo.get('nationality').hasError(validation.type) &&
                    (personalInfo.get('nationality').dirty ||
                    personalInfo.get('nationality').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Date Of Birth</mat-label>
        <input matInput readonly [matDatepicker]="picker" formControlName="DOB">
        <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
        <mat-datepicker #picker></mat-datepicker>
        <mat-error *ngFor="let validation of validationMessages.DOB">
          <mat-error class="error-message" *ngIf="  
              personalInfo.get('DOB').hasError(validation.type) &&
                  (personalInfo.get('DOB').dirty ||
                  personalInfo.get('DOB').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Town of Birth</mat-label>
        <input matInput placeholder="" formControlName="town" [value]="personalInfo.value.town" required
          autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.town">
          <mat-error class="error-message" *ngIf="  
              personalInfo.get('town').hasError(validation.type) &&
                  (personalInfo.get('town').dirty ||
                  personalInfo.get('town').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Marital Status</mat-label>
        <mat-select name="status" formControlName="maritalStatus">
          <mat-option *ngFor="let status of maritalStatus" [value]="status.code">
            {{status.name}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.maritalStatus">
          <mat-error class="error-message" *ngIf="  
                personalInfo.get('maritalStatus').hasError(validation.type) &&
                    (personalInfo.get('maritalStatus').dirty ||
                    personalInfo.get('maritalStatus').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field class="email-field" appearance="standard">
        <mat-label>Religion</mat-label>
        <mat-select name="religion" formControlName="religion">
          <mat-option *ngFor="let status of religions" [value]="status.code">
            {{status.name}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.religion">
          <mat-error class="error-message" *ngIf="  
              personalInfo.get('religion').hasError(validation.type) &&
                  (personalInfo.get('religion').dirty ||
                  personalInfo.get('religion').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="false">
    <mat-expansion-panel-header>
      <mat-panel-title>
        Contact Information
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="contactInfo">
      <mat-form-field appearance="standard" [ngClass]="{'sub-list' : showOtherCountryCode}" *ngIf="!isModel">
        <mat-label>Country Code</mat-label>
        <input *ngIf='!(countryCodes?.length > 0)' type="text" matInput placeholder=""
          [value]="contactInfo.value.countryCode" formControlName="countryCode" required autocomplete="off" />
        <mat-select *ngIf='countryCodes?.length > 0' name="countryCode" formControlName="countryCode">
          <mat-option *ngFor="let code of countryCodes" [value]="code"
            (onSelectionChange)="updateOthersField($event, 'countryCode', code)">
            {{code}}
          </mat-option>
          <mat-option (onSelectionChange)="updateOthersField($event, 'countryCode', 'Others')" value="Others">
            Others
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.countryCode">
          <mat-error class="error-message" *ngIf="  
          contactInfo.get('countryCode').hasError(validation.type) &&
                (contactInfo.get('countryCode').dirty ||
                contactInfo.get('countryCode').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field *ngIf="showOtherCountryCode && !isModel" class="sub-list" appearance="standard">
        <mat-label>Other Country Code</mat-label>
        <input type="text" matInput formControlName="otherCountryCode" placeholder="" required autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.otherCountryCode">
          <mat-error class="error-message" *ngIf="  
          contactInfo.get('otherCountryCode').hasError(validation.type) &&
                (contactInfo.get('otherCountryCode').dirty ||
                contactInfo.get('otherCountryCode').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Phone Number</mat-label>
        <input type="number" matInput formControlName="phoneNo" placeholder="" [value]="contactInfo.value.phoneNo"
          required autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.phoneNo">
          <mat-error class="error-message" *ngIf="  
            contactInfo.get('phoneNo').hasError(validation.type) &&
                (contactInfo.get('phoneNo').dirty ||
                contactInfo.get('phoneNo').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Email Address</mat-label>
        <input type="email" matInput formControlName="email" placeholder="" [value]="contactInfo.value.email" required
          autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.email">
          <mat-error class="error-message" *ngIf="  
            contactInfo.get('email').hasError(validation.type) &&
                (contactInfo.get('email').dirty ||
                contactInfo.get('email').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="false">
    <mat-expansion-panel-header>
      <mat-panel-title>
        Employment Information
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="employmentInfo">
      <mat-form-field appearance="standard">
        <mat-label>Employee Number</mat-label>
        <input type="text" matInput formControlName="empNo" placeholder=""
          [value]="formData.employeeNumber ? formData.employeeNumber :employmentInfo.value.empNo" required
          autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.empNo">
          <mat-error class="error-message" *ngIf="  
            employmentInfo.get('empNo').hasError(validation.type) &&
                (employmentInfo.get('empNo').dirty ||
                employmentInfo.get('empNo').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Joining Date</mat-label>
        <input matInput readonly [matDatepicker]="jdpicker" formControlName="joiningDate">
        <mat-datepicker-toggle matSuffix [for]="jdpicker"></mat-datepicker-toggle>
        <mat-datepicker #jdpicker></mat-datepicker>
        <mat-error *ngFor="let validation of validationMessages.joiningDate">
          <mat-error class="error-message" *ngIf="  
            employmentInfo.get('joiningDate').hasError(validation.type) &&
                (employmentInfo.get('joiningDate').dirty ||
                employmentInfo.get('joiningDate').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard" [ngClass]="{'sub-list' : showJobTitleField}">
        <mat-label>Job Title</mat-label>
        <input *ngIf='!(jobTitles?.length > 0)' type="text" matInput placeholder=""
          [value]="employmentInfo.value.jobTitle" formControlName="jobTitle" required autocomplete="off" />
        <mat-select *ngIf='jobTitles?.length > 0' name="jobTitle" formControlName="jobTitle">
          <mat-option *ngFor="let jobTitle of jobTitles" [value]="jobTitle"
            (onSelectionChange)="updateOthersField($event, 'jobTitle', jobTitle)">
            {{jobTitle}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.jobTitle">
          <mat-error class="error-message" *ngIf="  
            employmentInfo.get('jobTitle').hasError(validation.type) &&
                (employmentInfo.get('jobTitle').dirty ||
                employmentInfo.get('jobTitle').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field *ngIf="showJobTitleField" class="sub-list" appearance="standard">
        <mat-label>Other Job Title</mat-label>
        <input type="text" matInput formControlName="othersjobTitles" placeholder="" required autocomplete="off" />
      </mat-form-field>
      <mat-form-field appearance="standard" [ngClass]="{'sub-list' : showGradeField}">
        <mat-label>Grade</mat-label>
        <input *ngIf='!(grades?.length > 0)' type="text" matInput placeholder="" [value]="employmentInfo.value.grade"
          formControlName="grade" required autocomplete="off" />
        <mat-select *ngIf='grades?.length > 0' name="grade" formControlName="grade">
          <mat-option *ngFor="let grade of grades" [value]="grade"
            (onSelectionChange)="updateOthersField($event, 'grade', grade)">
            {{grade}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.grade">
          <mat-error class="error-message" *ngIf="  
            employmentInfo.get('grade').hasError(validation.type) &&
                (employmentInfo.get('grade').dirty ||
                employmentInfo.get('grade').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field *ngIf="showGradeField" class="sub-list" appearance="standard">
        <mat-label>Other Grade</mat-label>
        <input type="number" matInput formControlName="othersgrade" placeholder="" required autocomplete="off" />
      </mat-form-field>
      <mat-form-field appearance="standard" [ngClass]="{'sub-list' : showDeptField}">
        <mat-label>Department</mat-label>
        <input *ngIf='!(departments?.length > 0)' type="text" matInput placeholder=""
          [value]="employmentInfo.value.department" formControlName="department" required autocomplete="off" />
        <mat-select *ngIf='departments?.length > 0' name="department" formControlName="department">
          <mat-option *ngFor="let department of departments" [value]="department"
            (onSelectionChange)="updateOthersField($event, 'dept' , department)">
            {{department}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.department">
          <mat-error class="error-message" *ngIf="  
            employmentInfo.get('department').hasError(validation.type) &&
                (employmentInfo.get('department').dirty ||
                employmentInfo.get('department').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field *ngIf="showDeptField" class="sub-list" appearance="standard">
        <mat-label>Other Department</mat-label>
        <input type="text" matInput formControlName="othersdept" placeholder="" required autocomplete="off" />
      </mat-form-field>
      <mat-form-field appearance="standard" [ngClass]="{'sub-list' : showDivField}">
        <mat-label>Division</mat-label>
        <input *ngIf='!(divisions?.length > 0)' type="text" matInput placeholder="" formControlName="division"
          [value]="employmentInfo.value.division" required autocomplete="off" />
        <mat-select *ngIf='divisions?.length > 0' name="division" formControlName="division">
          <mat-option *ngFor="let division of divisions" [value]="division"
            (onSelectionChange)="updateOthersField($event, 'division', division)">
            {{division}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.division">
          <mat-error class="error-message" *ngIf="  
            employmentInfo.get('division').hasError(validation.type) &&
                (employmentInfo.get('division').dirty ||
                employmentInfo.get('division').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field *ngIf="showDivField" class="sub-list" appearance="standard">
        <mat-label>Other Division</mat-label>
        <input type="text" matInput formControlName="othersdiv" placeholder="" required autocomplete="off" />
      </mat-form-field>
      <mat-form-field *ngIf="supervisorIds.length == 0" appearance="standard">
        <mat-label>Supervisor Employee ID</mat-label>
        <input *ngIf="!(supervisorIds?.length >  0)" type="number" matInput placeholder=""
          [value]="employmentInfo.value.supEmpId" formControlName="supEmpId" required autocomplete="off" />
        <mat-select *ngIf="supervisorIds?.length >  0" name="supEmpId" formControlName="supEmpId">
          <mat-option *ngFor="let id of supervisorIds" [value]="id">
            {{id}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.supEmpId">
          <mat-error class="error-message" *ngIf="  
            employmentInfo.get('supEmpId').hasError(validation.type) &&
                (employmentInfo.get('supEmpId').dirty ||
                employmentInfo.get('supEmpId').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field *ngIf="supervisorIds.length > 0" appearance="standard">
        <mat-label>Supervisor Employee ID</mat-label>
        <mat-select name="supervisorIds" formControlName="supEmpId">
          <mat-option *ngFor="let listId of supervisorIds" [value]="listId">
            {{listId}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field appearance="standard" [ngClass]="{'sub-list' : showLocField}">
        <mat-label>Location</mat-label>
        <mat-select name="location" formControlName="location">
          <mat-option *ngFor="let status of location" [value]="status" (onSelectionChange)="updateOthersField($event, 'location', status)">
            {{status}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.location">
          <mat-error class="error-message" *ngIf="  
            employmentInfo.get('location').hasError(validation.type) &&
                (employmentInfo.get('location').dirty ||
                employmentInfo.get('location').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field *ngIf="showLocField" class="sub-list" appearance="standard">
        <mat-label>Other Location</mat-label>
        <input type="text" matInput formControlName="othersloc" placeholder="" required autocomplete="off" />
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Profession on Iqama</mat-label>
        <input type="text" matInput placeholder="" formControlName="iqamaProfession"
          [value]="employmentInfo.value.iqamaProfession" required autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.iqamaProfession">
          <mat-error class="error-message" *ngIf="  
            employmentInfo.get('iqamaProfession').hasError(validation.type) &&
                (employmentInfo.get('iqamaProfession').dirty ||
                employmentInfo.get('iqamaProfession').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="false">
    <mat-expansion-panel-header>
      <mat-panel-title>
        Contract Details
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="contractDetails">
      <mat-form-field appearance="standard">
        <mat-label>Basic Salary</mat-label>
        <input type="number" matInput placeholder="" formControlName="basicSalary"
          [value]="contractDetails.value.basicSalary" required autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.basicSalary">
          <mat-error class="error-message" *ngIf="  
            contractDetails.get('basicSalary').hasError(validation.type) &&
                (contractDetails.get('basicSalary').dirty ||
                contractDetails.get('basicSalary').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Contract Status</mat-label>
        <mat-select name="contractStatus" formControlName="contractStatus">
          <mat-option *ngFor="let status of contractStatuses" [value]="status.code">
            {{status.name}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.contractStatus">
          <mat-error class="error-message" *ngIf="  
            contractDetails.get('contractStatus').hasError(validation.type) &&
                (contractDetails.get('contractStatus').dirty ||
                contractDetails.get('contractStatus').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="false">
    <mat-expansion-panel-header>
      <mat-panel-title>
        Bank Details
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="bankDetails">
      <mat-form-field appearance="standard">
        <mat-label>Bank Name</mat-label>
        <mat-select name="bankName" formControlName="bankName">
          <mat-option *ngFor="let bank of banks" [value]="bank.code">
            {{bank.name}} - {{bank.code}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.bankName">
          <mat-error class="error-message" *ngIf="  
            bankDetails.get('bankName').hasError(validation.type) &&
                (bankDetails.get('bankName').dirty ||
                bankDetails.get('bankName').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Bank Code</mat-label>
        <input type="text" matInput placeholder="" formControlName="bankCode" [value]="bankDetails.value.bankCode"
          required autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.bankCode">
          <mat-error class="error-message" *ngIf="  
            bankDetails.get('bankCode').hasError(validation.type) &&
                (bankDetails.get('bankCode').dirty ||
                bankDetails.get('bankCode').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>IBAN #</mat-label>
        <input type="text" matInput placeholder="" formControlName="IBAN" [value]="bankDetails.value.IBAN" required
          autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.IBAN">
          <mat-error class="error-message" *ngIf="  
            bankDetails.get('IBAN').hasError(validation.type) &&
                (bankDetails.get('IBAN').dirty ||
                bankDetails.get('IBAN').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
    </form>
  </mat-expansion-panel>
  <mat-expansion-panel [expanded]="false">
    <mat-expansion-panel-header>
      <mat-panel-title>
        Allowance & Insurance
      </mat-panel-title>
    </mat-expansion-panel-header>
    <form [formGroup]="allowanceDetailsForm">
      <mat-form-field appearance="standard">
        <mat-label>Housing Percentage</mat-label>
        <input type="number" matInput placeholder="" formControlName="housingPercentage"
          [value]="allowanceDetailsForm.value.housingPercentage" required autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.housingPercentage">
          <mat-error class="error-message" *ngIf="  
            allowanceDetailsForm.get('housingPercentage').hasError(validation.type) &&
                (allowanceDetailsForm.get('housingPercentage').dirty ||
                allowanceDetailsForm.get('housingPercentage').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Transportation Percentage</mat-label>
        <input type="number" matInput placeholder="" formControlName="transportationPercentage"
          [value]="allowanceDetailsForm.value.transportationPercentage" required autocomplete="off" />
        <mat-error *ngFor="let validation of validationMessages.transportationPercentage">
          <mat-error class="error-message" *ngIf="  
            allowanceDetailsForm.get('transportationPercentage').hasError(validation.type) &&
                (allowanceDetailsForm.get('transportationPercentage').dirty ||
                allowanceDetailsForm.get('transportationPercentage').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard">
        <mat-label>Overtime</mat-label>
        <mat-select name="overtime" formControlName="overtime">
          <mat-option *ngFor="let status of yesOrNoOtions" [value]="status">
            {{status}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.overtime">
          <mat-error class="error-message" *ngIf="  
            allowanceDetailsForm.get('overtime').hasError(validation.type) &&
                (allowanceDetailsForm.get('overtime').dirty ||
                allowanceDetailsForm.get('overtime').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field appearance="standard" [ngClass]="{'sub-list' : showOtherMIField}">
        <mat-label>Medical Insurance</mat-label>
        <input *ngIf='!(medicalInsurences?.length > 0)' type="text" matInput placeholder=""
          [value]="allowanceDetailsForm.value.medicalInsurence" formControlName="medicalInsurence" required
          autocomplete="off" />
        <mat-select *ngIf='medicalInsurences?.length > 0' name="medicalInsurence" formControlName="medicalInsurence">
          <mat-option *ngFor="let medicalInsurence of medicalInsurences" [value]="medicalInsurence"
            (onSelectionChange)="updateOthersField($event, 'medicalInsurence', medicalInsurence)">
            {{medicalInsurence}}
          </mat-option>
        </mat-select>
        <mat-error *ngFor="let validation of validationMessages.medicalInsurence">
          <mat-error class="error-message" *ngIf="  
          allowanceDetailsForm.get('medicalInsurence').hasError(validation.type) &&
                (allowanceDetailsForm.get('medicalInsurence').dirty ||
                allowanceDetailsForm.get('medicalInsurence').touched)">{{ validation.message }}</mat-error>
        </mat-error>
      </mat-form-field>
      <mat-form-field *ngIf="showOtherMIField" class="sub-list" appearance="standard">
        <mat-label>Other Medical Insurance</mat-label>
        <input type="text" matInput formControlName="otherMI" placeholder="" autocomplete="off" />
      </mat-form-field>
    </form>
  </mat-expansion-panel>
</mat-accordion>
<div class="button-container">
  <button mat-raised-button (click)="closeModel(false)" *ngIf="isModel" class="submit-btn">
    Cancel
  </button>
  <button *ngIf="!isModel" mat-raised-button (click)="onSubmitForm()"
    [disabled]="!personalInfo.valid || !contactInfo.valid || !employmentInfo.valid || !contractDetails.valid || !bankDetails.valid || !allowanceDetailsForm.valid"
    class="submit-btn">
    Submit
  </button>
  <button *ngIf="isModel" mat-raised-button (click)="onSubmitForm('CORRECTION')"
    [disabled]="!cfd.valid || !personalInfo.valid || !contactInfo.valid || !employmentInfo.valid || !contractDetails.valid || !bankDetails.valid || !allowanceDetailsForm.valid"
    class="submit-btn">
    Correction
  </button>
  <button *ngIf="isModel" mat-raised-button (click)="onSubmitForm('UPDATE')"
    [disabled]="!cfd.valid || !personalInfo.valid || !contactInfo.valid || !employmentInfo.valid || !contractDetails.valid || !bankDetails.valid || !allowanceDetailsForm.valid"
    class="submit-btn">
    Change
  </button>
</div>